## vue-cropper
 [preview](http://xyxiao.cn/vue-cropper/example/)
 <br />
 [中文](https://github.com/xyxiao001/vue-cropper)
# vue-cropper

## update log
### v0.27
### Optimization of mouse scaling problem
### img max-width
### add props  
#### canMove  can move a picture  default true
#### canMoveBox can move crop box  default true
#### original  img original size   default false

### v0.26
### Fix Firefox browser mouse scaling problem
### v0.25
#### fixed img show
### v0.24
#### Repair IOS photos, rotate screenshot problem, add automatic repair screenshots,
#### preview code changes, modify the default upload picture for blob Preview
```
realTime (data) {
  this.previews = data
}
<div class="show-preview" :style="{'width': previews.w + 'px', 'height': previews.h + 'px',  'overflow': 'hidden',
    'margin': '5px'}">
  <div :style="previews.div">
    <img :src="previews.url" :style="previews.img">
  </div>
</div>
```
### v0.22
#### Added new picture size function called by this.$refs.cropper.changeScale
### v0.21
#### new fixed frame size fiexdBox screenshot (Note: the best collocation automatically generated box using the screenshot)
### v0.20
### add props full -> Original scale output, fixes the big picture zoom sensitivity
### v0.19 New picture rotation fix MAC roller over sensitive
```
this.$cropper.rotateRight() turn left 90°C
this.$cropper.rotateLeft()  turn right 90°C
```

### v0.18 repair box over the container error generated by default.
### v0.17 repair BLOB data acquisition error
### v0.15 add touchscale
```
canScale: true
```
### v0.13 add Real time preview
```
@realTime="realTime"
// Real time preview function
realTime (data) {
  this.previews = data
}
<div class="show-preview" :style="{'width': previews.w + 'px', 'height': previews.h + 'px',  'overflow': 'hidden',
    'margin': '5px'}">
  <div :style="previews.div">
    <img :src="option.img" :style="previews.img">
  </div>
</div>
```

####   install
```
npm install vue-cropper
```
####   use  
```
import VueCropper from vue-cropper
```

```
<vueCropper
  ref="cropper"
  :img="option.img"
  :outputSize="option.size"
  :outputType="option.outputType"
></vueCropper>
```
<table style="text-align: center">
  <thead>
    <tr>
        <td>name</td>
        <td>toDo</td>
        <td>default</td>
        <td>optional</td>
    </tr>
  </thead>
  <tbody>
    <tr>
        <td>img</td>
        <td>img url</td>
        <td>null</td>
        <td>url || base64 || blob</td>
    </tr>
    <tr>
        <td>outputSize</td>
        <td>crop produces quality of pictures</td>
        <td>1</td>
        <td>0.1 - 1</td>
    </tr>
    <tr>
        <td>outputType</td>
        <td>crop img output type</td>
        <td>jpg (jpg need jpeg)</td>
        <td>jpeg || png || webp</td>
    </tr>
    <tr>
        <td>info</td>
        <td>crop box size show</td>
        <td>true</td>
        <td>true || false</td>
    </tr>
    <tr>
        <td>canScale</td>
        <td>the scroll to scale</td>
        <td>true</td>
        <td>true || false</td>
    </tr>
    <tr>
        <td>autoCrop</td>
        <td>auto create crop box</td>
        <td>false</td>
        <td>true || false</td>
    </tr>
    <tr>
        <td>autoCropWidth</td>
        <td>auto crop box width</td>
        <td>box size 80%</td>
        <td>0~max</td>
    </tr>
    <tr>
        <td>autoCropHeight</td>
        <td>auto create crop box height</td>
        <td>box size 80%</td>
        <td>0~max</td>
    </tr>
    <tr>
        <td>fixed</td>
        <td>open crop box width height ratio</td>
        <td>true</td>
        <td>true | false</td>
    </tr>
    <tr>
        <td>fixedNumber</td>
        <td>crop box width height ratio</td>
        <td>[1 : 1]</td>
        <td>[w : h]</td>
    </tr>
    <tr>
        <td>full</td>
        <td>output a screenshot of the original scale</td>
        <td>false</td>
        <td>true | false</td>
    </tr>
    <tr>
        <td>fixedBox</td>
        <td>Fixed screenshot box sizes are not allowed to change</td>
        <td>false</td>
        <td>true | false</td>
    </tr>
    <tr>
        <td>canMove</td>
        <td>can move img</td>
        <td>true</td>
        <td>true | false</td>
    </tr>
    <tr>
        <td>canMoveBox</td>
        <td>can move crop box</td>
        <td>true</td>
        <td>true | false</td>
    </tr>
    <tr>
        <td>original</td>
        <td>img original size</td>
        <td>false</td>
        <td>true | false</td>
    </tr>
  </tbody>
</table>


### function  adopt this.$refs.cropper to use
##### start cropper
```
this.$refs.cropper.startCrop()
```
##### stop cropper
```
this.$refs.cropper.stopCrop()
```
##### clear cropper
```
this.$refs.cropper.clearCrop()
```
##### get output img base64
```
this.$refs.cropper.getCropData((data) => {
  // do something
  console.log(data)  
})
```

### get output img blob
```
this.$refs.cropper.getCropBlob((data) => {
  // do something
  console.log(data)  
})
```

### change img  scale
```
 this.$refs.cropper.changeScale(num)
 num  > 0  scale ++
 num < 0  scale --
```
